//------//------//------//------//------//------//------//------//------//------//------//------
//
// Sample : IAudioClient_PlayStream
//
//------//------//------//------//------//------//------//------//------//------//------//------
//------//------//------//------//------//------//------//------//------//------//------//------
// include
//------//------//------//------//------//------//------//------//------//------//------//------
#include <stdio.h>
#include <math.h>
#include <windows.h>
#include <mmdeviceapi.h>
#include <audiopolicy.h>
#include <Avrt.h>


//------//------//------//------//------//------//------//------//------//------//------//------
// pragma
//------//------//------//------//------//------//------//------//------//------//------//------
#pragma   comment(lib,     "winmm.lib")
#pragma   comment(lib,     "user32.lib")
#pragma   comment(lib,     "avrt.lib")
#pragma   comment(lib,     "ole32.lib")

//------//------//------//------//------//------//------//------//------//------//------//------
// define
//------//------//------//------//------//------//------//------//------//------//------//------
#define   HRES(x)          {HRESULT hr; if (hr = (x)) { printf("HRES LINE %d: ERROR : %08X\n", __LINE__, hr); break;} }
#define   RELEASE(x)       {            if ((x))      { (x)->Release(); (x) = NULL; } }

#define   REF_PER_SEC       10000000
#define   REF_PER_MILLISEC  10000

//------//------//------//------//------//------//------//------//------//------//------//------
// tkt-
//------//------//------//------//------//------//------//------//------//------//------//------
void IAudioClient_ShowSupport(IAudioClient *dev, WAVEFORMATEXTENSIBLE *pfmt)
{
  DWORD bits[]               = { 16, 24, 32, 0 };
  DWORD rates[]              = { 22050, 44100, 48000, 96000, 192000, 0, };
  AUDCLNT_SHAREMODE shares[] = { AUDCLNT_SHAREMODE_EXCLUSIVE, AUDCLNT_SHAREMODE_SHARED, };
  GUID SubFormat[]           = { KSDATAFORMAT_SUBTYPE_PCM, KSDATAFORMAT_SUBTYPE_IEEE_FLOAT };
  WAVEFORMATEXTENSIBLE wfmtex;
  
  HRESULT hr = E_FAIL;
  WAVEFORMATEX *cmfmt = NULL;
  WAVEFORMATEXTENSIBLE fmt  = *(WAVEFORMATEXTENSIBLE *)pfmt;
  for(int b = 0; bits[b]; b++)
  {
    for(int r = 0; rates[r]; r++)
    {
      for(int format = 0; format < 2; format++)
      {
        for(int sindex  = 0; sindex < 2; sindex++)
        {
          fmt.Format.wBitsPerSample = bits[b];
          fmt.Format.nSamplesPerSec = rates[r];
          fmt.SubFormat      = SubFormat[format];
          if(dev->IsFormatSupported(shares[sindex], &fmt.Format, &cmfmt) != AUDCLNT_E_UNSUPPORTED_FORMAT)
          {
            printf("Support : TYPE:%s  MODE:%s :  bits:%d, rates:%d\n",
            format == 0 ? "PCM  " : "FLOAT", sindex == 0 ? "EX" : "SH", bits[b], rates[r]);
          }
        }
      }
    }
  }
}

//------//------//------//------//------//------//------//------//------//------//------//------
// base : http://msdn.microsoft.com/en-us/library/windows/desktop/dd316756(v=vs.85).aspx
//        http://msdn.microsoft.com/en-us/library/windows/desktop/dd370844(v=vs.85).aspx
//------//------//------//------//------//------//------//------//------//------//------//------
HRESULT IAudioClient_PlayStream(void (*cb_synth)(void *pdata, int numframes, WAVEFORMATEXTENSIBLE *fmt), BOOL (*cb_done)())
{
  if(!cb_synth || !cb_done) return E_FAIL;

  //AUDCLNT_SHAREMODE      share_mode           = AUDCLNT_SHAREMODE_EXCLUSIVE;
  AUDCLNT_SHAREMODE      share_mode           = AUDCLNT_SHAREMODE_SHARED;
  DWORD                  StreamFlags          = AUDCLNT_STREAMFLAGS_EVENTCALLBACK | AUDCLNT_STREAMFLAGS_NOPERSIST;
  IMMDeviceEnumerator   *pEnumerator          = NULL;
  IMMDevice             *pDevice              = NULL;
  IAudioClient          *pAudioClient         = NULL;
  IAudioRenderClient    *pRenderClient        = NULL;
  REFERENCE_TIME         DefReqDuration = 0;
  REFERENCE_TIME         hnsReqDuration = 0;  
  UINT32                 bufferFrameCount     = 0;
  HANDLE                 hEvent               = NULL;
  HANDLE                 hTask                = NULL;
  WAVEFORMATEXTENSIBLE   wfmtex               = {0};
  WAVEFORMATEXTENSIBLE  *temp                 = &wfmtex;
  WAVEFORMATEX          *pwfx                 = NULL;
  DWORD                  taskIndex            = 0;
  
  do //for err
  {
    //Initialize
    HRES(CoCreateInstance(__uuidof(MMDeviceEnumerator), NULL, CLSCTX_ALL, __uuidof(IMMDeviceEnumerator), (void**)&pEnumerator));
    HRES(pEnumerator->GetDefaultAudioEndpoint(eRender, eConsole, &pDevice));
    HRES(pDevice->Activate(__uuidof(IAudioClient), CLSCTX_ALL, NULL, (void**)&pAudioClient));
    {
      WAVEFORMATEX *fmt = NULL;
      HRES(pAudioClient->GetMixFormat(&fmt)); //Shared̃tH[}bgԋp
      wfmtex = *(WAVEFORMATEXTENSIBLE *)fmt;
      CoTaskMemFree(fmt);
      temp  = &wfmtex;
      pwfx  = (WAVEFORMATEX *)temp;
    }
    IAudioClient_ShowSupport(pAudioClient, &wfmtex);
    
    HRES(pAudioClient->GetDevicePeriod(&DefReqDuration, &hnsReqDuration));
    
    //EXCLUSIVȄꍇWAVEFORMATEXTENSIBLEgĂ@̃vpeBɍ킹ȂInitializes
    //FillƂRvpeBɍ킹ȂƂȂB
    HRES(pAudioClient->Initialize(share_mode, StreamFlags, DefReqDuration, DefReqDuration, pwfx, NULL));
    HRES(pAudioClient->GetBufferSize(&bufferFrameCount));
    HRES(pAudioClient->GetService(__uuidof(IAudioRenderClient), (void**)&pRenderClient));
    hTask  = AvSetMmThreadCharacteristics(TEXT("WASAPI Audio"), &taskIndex);
    hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
    HRES(pAudioClient->SetEventHandle(hEvent));
    HRES(pAudioClient->Start());
    
    //Start Stream
    while (!cb_done())
    {
      DWORD flags = 0;
      BYTE *pData = NULL;
      if(WaitForSingleObject(hEvent, INFINITE) != WAIT_OBJECT_0) break;
      UINT32 numFramesPadding = 0;
      HRES(pAudioClient->GetCurrentPadding(&numFramesPadding));
      UINT32 numFramesAvailable = bufferFrameCount - numFramesPadding;
      HRES(pRenderClient->GetBuffer(numFramesAvailable, &pData));
      if(pData)
      {
        cb_synth(pData, numFramesAvailable, temp);
        HRES(pRenderClient->ReleaseBuffer(numFramesAvailable, flags));
      }
    }
  } while(0);
  
  //release
  if(pAudioClient)
  {
    Sleep((DWORD)(DefReqDuration / REF_PER_MILLISEC));
    pAudioClient->Stop();
  }
  if (hTask ) AvRevertMmThreadCharacteristics(hTask);
  if (hEvent) CloseHandle(hEvent);
  RELEASE(pEnumerator);
  RELEASE(pDevice);
  RELEASE(pAudioClient);
  RELEASE(pRenderClient);
  
  printf("Done. %s\n", __FUNCTION__);
  return S_OK;
}





//------//------//------//------//------//------//------//------//------
//user
//------//------//------//------//------//------//------//------//------
void CallBackSynth(void *p, int frames, WAVEFORMATEXTENSIBLE *fmtex)
{
  static double ph      = 0;
  static double lfo     = 0;
  static double volume  = 0;
  static int    hz      = 440;
  double        mp      = 1.0 / float(fmtex->Format.nSamplesPerSec);
  float        *buf     = (float *)p;
  double        dph     = hz * mp;
  double        dlfo    = 5  * mp;
  if(GetAsyncKeyState(VK_SPACE) & 0x8000)
  {
    volume = 1;
    hz = (rand() & 0x1FF) + 440;
  }
  volume *= 0.99;
  //fill
  for(int i = 0; i < frames; i++)
  {
    double mult = 1;
    float lfoh  = sin(sin(lfo * 2 * 3.14) * 3.7);
    float vol   = 0;
    vol += sin( (lfoh + 1.7) * sin(ph * 2 * 3.14 * mult)); mult *= 0.5;
    vol += sin( (lfoh + 1.7) * sin(ph * 2 * 3.14 * mult)); mult *= 0.5;
    vol += sin( (lfoh + 1.7) * sin(ph * 2 * 3.14 * mult)); mult *= 0.5;
    vol += sin( (lfoh + 1.7) * sin(ph * 2 * 3.14 * mult)); mult *= 0.5;
    
    //KB32bit FLOATȂ玨̂ŒӁB
    buf[0 + i * 2] = vol * volume ;
    buf[1 + i * 2] = vol * volume ;
    buf[0 + i * 2] /= 4.0;
    buf[1 + i * 2] /= 4.0;
    ph += dph;
    
    lfo += dlfo;
  }
}

BOOL CallBackIsDone()
{
  if(GetAsyncKeyState(VK_ESCAPE) & 0x8000) return TRUE;
  printf("SpaceL[łƂȂ܂\r");
  return FALSE;
}

int main()
{
  CoInitializeEx(NULL, COINIT_MULTITHREADED);
  
  IAudioClient_PlayStream(CallBackSynth, CallBackIsDone);
  CoUninitialize();
}
